{% extends "base_device.yaml.jinja2" %}

{% block device_setup %}
{%- set arch = "aarch64" %}
{%- set cpu = "cortex-a57" %}
{%- if settings.TARGET == "trs-qemuarm" %}
{%-   set arch = "arm" %}
{%-   set cpu = "cortex-a15" %}
{%- endif %}
device_type: qemu
job_name: {{ lava_job_name }}
timeouts:
  job:
    minutes: 60
  action:
    minutes: 60
  connection:
    minutes: 2
priority: 25
visibility: public
context:
  lava_test_results_dir: /var/lib/lava-%s
  arch: {{ arch }}
  machine: virt,secure=on
  cpu: {{ cpu }}
  guestfs_interface: virtio
  netdevice: user

actions:

- deploy:
    to: downloads
    failure_retry: 3
    timeout:
      minutes: 60
    images:
      {%- if testexport_url %}
      testexport:
        url: {{ testexport_url }}
      {%- endif %}
      os:
        {%- set os, _ = splitext(basename(os_url)) %}
        {%- set _, os_extension = splitext(os_url) %}
        url: {{ os_url }}
        compression: {{ os_extension[1:] }}
      firmware:
        {%- set firmware, _ = splitext(basename(firmware_url)) %}
        {%- set _, firmware_extension = splitext(firmware_url) %}
        url: {{ firmware_url }}
        compression: {{ firmware_extension[1:] }}
    postprocess:
      docker:
        image: debian
        steps:
          # Add 10G, required by OpenAD Kit Demo container
          - 'ls -hl {{ os }}'
          - 'qemu-img resize {{ os }} +10G'
          - 'ls -hl {{ os }}'

- deploy:
    failure_retry: 3
    timeout:
      minutes: 60
    to: tmpfs
    images:
      os:
        image_arg: -drive id=disk1,file={os},if=none,format=raw -device virtio-blk-device,drive=disk1
          -nographic -device i6300esb,id=watchdog0 -m 2048 -smp 4
        url: downloads://{{ os }}
      firmware:
        image_arg: -drive if=pflash,unit=0,readonly=off,file={firmware},format=raw
        url: downloads://{{ firmware }}

- boot:
    method: qemu
    media: tmpfs
    docker:
      image: registry.gitlab.com/linaro/blueprints/qemu-swtpm
      binary: /usr/local/bin/qemu-system-{{ arch }}-swtpm
    expect_shell: false
    timeout:
      minutes: 40
    auto_login:
      login_prompt: 'login:'
      username: "root"
    prompts:
      - ewaol@(.*):[/~]\$
      - root@(.*):[/~]#
    transfer_overlay:
      download_command: wget -t 20 --waitretry 20 --retry-connrefused --retry-on-host-error --retry-on-http-error=401,403
      unpack_command: tar -C /var/lib/ -xzvf
{% endblock %}
